<?php 
if (!defined('B_PROLOG_INCLUDED') || B_PROLOG_INCLUDED !== true) die();

$component = $this->getComponent();
$arParams = $component->applyTemplateModifications();

$arParams["PHOTOS_PROPERTY_CODE"] = $arParams["PHOTOS_PROPERTY_CODE"]?$arParams["PHOTOS_PROPERTY_CODE"]:'MORE_PHOTO';

$arResult["GALLERY"] = array();
if(is_array($arResult["DETAIL_PICTURE"]))
	$arResult["GALLERY"][] = $arResult["DETAIL_PICTURE"];
elseif(is_array($arResult["PREVIEW_PICTURE"]))
	$arResult["GALLERY"][] = $arResult["PREVIEW_PICTURE"];
if(isset($arResult["DISPLAY_PROPERTIES"][$arParams["PHOTOS_PROPERTY_CODE"]]["FILE_VALUE"]))
	$arResult["GALLERY"] = array_merge($arResult["GALLERY"],$arResult["DISPLAY_PROPERTIES"][$arParams["PHOTOS_PROPERTY_CODE"]]["FILE_VALUE"]['ID']?array($arResult["DISPLAY_PROPERTIES"][$arParams["PHOTOS_PROPERTY_CODE"]]["FILE_VALUE"]):$arResult["DISPLAY_PROPERTIES"][$arParams["PHOTOS_PROPERTY_CODE"]]["FILE_VALUE"]);
elseif(isset($arResult["PROPERTIES"][$arParams["PHOTOS_PROPERTY_CODE"]]["VALUE"]))
{
	foreach($arResult["PROPERTIES"][$arParams["PHOTOS_PROPERTY_CODE"]]["VALUE"] as $fileId)
	{
		if(!$file=\CFile::GetFileArray($fileId))
			continue;
		$arResult["GALLERY"][] = $file;
	}
}

$arParams['IMAGE_DETAIL_MAX_WIDTH'] = ($t=intval($arParams['IMAGE_DETAIL_MAX_WIDTH']))>0?$t:1024; 
$arParams['IMAGE_DETAIL_MAX_HEIGHT'] = ($t=intval($arParams['IMAGE_DETAIL_MAX_HEIGHT']))>0?$t:1024;
$arParams['IMAGE_PREVIEW_MAX_WIDTH'] = ($t=intval($arParams['IMAGE_PREVIEW_MAX_WIDTH']))>0?$t:768;
$arParams['IMAGE_PREVIEW_MAX_HEIGHT'] = ($t=intval($arParams['IMAGE_PREVIEW_MAX_HEIGHT']))>0?$t:768;
$arParams['IMAGE_THUMBNAIL_MAX_WIDTH'] = ($t=intval($arParams['IMAGE_THUMBNAIL_MAX_WIDTH']))>0?$t:316;
$arParams['IMAGE_THUMBNAIL_MAX_HEIGHT'] = ($t=intval($arParams['IMAGE_THUMBNAIL_MAX_HEIGHT']))>0?$t:316;
$arParams['IMAGE_JPG_QUALITY'] = ($t=strval($arParams['IMAGE_JPG_QUALITY']))>0?$t:85;

foreach($arResult["GALLERY"] as &$arPicture)
{
	$imageFile = $arPicture;
	$arPicture = array('ORIGINAL'=>$imageFile);
	$arPicture["DETAIL"] = \CFile::ResizeImageGet(
		$imageFile, // image file array
		array("width" => $arParams['IMAGE_DETAIL_MAX_WIDTH'], "height" => $arParams['IMAGE_DETAIL_MAX_HEIGHT']), // max sizes
		BX_RESIZE_IMAGE_PROPORTIONAL,
		true, // return resized image sizes
		array(array('name' => 'sharpen', 'precision' => 15)), // png correction
		false, // immediate
		$arParams['IMAGE_JPG_QUALITY'] // jpg quality
	);
	$arPicture["PREVIEW"] = \CFile::ResizeImageGet(
		$imageFile, // image file array
		array("width" => $arParams['IMAGE_PREVIEW_MAX_WIDTH'], "height" => $arParams['IMAGE_PREVIEW_MAX_HEIGHT']), // max sizes
		BX_RESIZE_IMAGE_PROPORTIONAL,
		true, // return resized image sizes
		array(array('name' => 'sharpen', 'precision' => 15)), // png correction
		false, // immediate
		$arParams['IMAGE_JPG_QUALITY'] // jpg quality
	);
	$arPicture["THUMBNAIL"] = \CFile::ResizeImageGet(
		$imageFile, // image file array
		array("width" => $arParams['IMAGE_THUMBNAIL_MAX_WIDTH'], "height" => $arParams['IMAGE_THUMBNAIL_MAX_HEIGHT']), // max sizes
		BX_RESIZE_IMAGE_PROPORTIONAL,
		true, // return resized image sizes
		array(array('name' => 'sharpen', 'precision' => 15)), // png correction
		false, // immediate
		$arParams['IMAGE_JPG_QUALITY'] // jpg quality
	);
}
unset($arPicture);

$this->__component->SetResultCacheKeys(array(
	'MEASURE',
	'MEASURE_RATIO',
	'GALLERY',
	'NAME',
	'PRICES',
	'ITEM_PRICES',
	'PREVIEW_TEXT',
	'DETAIL_TEXT',
	'FIELDS',
	'PROPERTIES',
	'DISPLAY_PROPERTIES',
	'PRODUCT',
	'IBLOCK_SECTION_ID',
	'sizes',
	'modifiers',
	'modifierFields',	
	'productData',
));

